function ba = bam(ts, wavelet, par)
%
%
if nargin < 2
    wavelet = 'Haar'; par = 1; policy = 'Hard'; 
end
n = length(ts);
%per = pdgrm( ts ); %find periodogtam, but for \omega > 0, n/2 values
per = periodogram( ts ); per = [per(end-floor(n/2)+2); per(end-floor(n/2)+2:end)]; %find periodogtam, but for \omega > 0, n/2 values
logper = log( per ); 
%because of boundary effects, extend logper with mirror boundaries
flogper = [ reverse(logper(1:n/4)); logper;  logper(end : -1 : end-n/4+1) ];
% and proceed smoothing the extended signal
%---------------------------------
wfil = MakeONFilter(wavelet, par);
nlev = log2(n);
wlogper = FWT_PO( flogper, 0, wfil );
wlogperth = wlogper;
% Explore those...
     lams = [0.354 0.178 0.141 0.053  linspace(0.02,0.001, nlev-4)];
%     lamjs = lams(nlev-j);
%     nujs = 0.1*2^j; 
%     betajs = 0.3* 2^(5*j)/(n^2);
% shrinkage by:   bamspd
for  j = nlev-1:-1:0
    lamjs = 0.1  * j/(nlev-1) + 0.9 * (nlev-j-1)/(nlev-1); %was = pij
    betajs  = 0.9 * j/(nlev-1) + 0.1 * (nlev-j-1)/(nlev-1); %was = lamj
nujs = (1 - lamjs) * (j+2);
    level_in = wlogper(dyad(j));
    wlogperth(dyad(j)) = bamspd( level_in, n, nujs, lamjs, betajs); 
end
ba = IWT_PO( wlogperth, 0, wfil ); %return extended to the time domain
ba = ba(n/4+1 : n/4+n/2); % take only a part corresponding to the 
% range of original logper
    
    
