function ga = gao(ts, policy, skew, wavelet, par)
%
%
if nargin < 2
    wavelet = 'Haar'; par = 1; policy = 'Hard'; skew=0.1;
end
n = length(ts);

per = periodogram( ts ); per = [per(end-floor(n/2)+2); per(end-floor(n/2)+2:end)]; %find periodogtam, for omega in -pi,pi
% then take only Fourier frequencies > 0.
logper = log( per ); 
%because of boundary effects, extend logper with mirror boundaries
flogper = [ reverse(logper(1:n/4)); logper;  logper(end : -1 : end-n/4+1) ];
% and proceed smoothing the extended signal
%---------------------------------
wfil = MakeONFilter(wavelet, par);
nlev = log2(n);
wlogper = FWT_PO( flogper, 0, wfil );
wlogperth = wlogper;
% gao's constants; he calls them alpha_i
gao_const = [1.29 1.09 0.92 0.77 0.65 0.54 0.46 0.39 0.32 0.27];
% threshold
for  i = nlev-1:-1:0
    j = nlev-i;
    if j <= 10 %finest ten levels use gao_const
        thresh = gao_const(j) * log(n/2);
    else        % the coarser, if exist, use CLT based normal threshold
        thresh = pi/sqrt(3) * sqrt(log(n/2));
    end
    help = wlogper(dyad(i));
    if   policy =='h' | policy == 'H'
       wlogperth(dyad(i)) = help .* (abs(help) > thresh );
    elseif   policy =='s' | policy =='S'
       wlogperth(dyad(i)) = (help -  sign(help) .* thresh) .* (abs(help) > thresh );  
    elseif policy == 'a' | policy =='A'
      wlogperth(dyad(i)) = help  .* (1 - (help < (1-skew) * thresh).*( - help < (1+skew)* thresh));    
    else
    error('Unknown policy. Policy is either "hard","soft","assymetric",or "soft-hard" ')
    end
end
ga = IWT_PO( wlogperth, 0, wfil ); %return extended to the time domain
ga = ga(n/4+1 : n/4+n/2); % take only a part corresponding to the 
% range of original logper
    
    
